%define ALD_Ver		1.2.4


Name:         wpa

License:      BSD
Summary:      wpa_supplicant
Group:        System Environment/Libraries
Version:      2.4
Release:      0

Source: %{name}-%{version}.tar.xz
Source1: CROSS.sh
Source2: %{name}-%{version}-patches.tgz

%define BUIL_WPA_GUI	1

%define DestDir		/net
%define _exec_prefix %{nil}

# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%else
# rpm --target=x86_64/armv6l/win32 -ba xxxxx.spec
%define _CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%define _libexecdir	%{_sbindir}

%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif
%define target_  %{target}-

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin

%define __os_install_post %{nil}

%define cross_sysconfdir %{csysdir}%{_sysconfdir}
%define cross_bindir	%{csysdir}%{_bindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_docdir	%{cross_defaultdocdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_build}
%define target_  %{nil}

%endif # !_CROSS

%define docdir %{_defaultdocdir}/%{name}

# ------------------- description ------------------------------------
%description
Convenience library for netlink sockets
#-------------------------------
%package gui
Summary:      QT4 Graphical user interface for wpa_supplicant
Group:        Development/Libraries
%description gui
QT4 Graphical user interface for wpa_supplicant
#-------------------------------
%package %{TO_ARCH}
Summary:      %{name} Cross-%{TO_ARCH} Libraries
Group:        Development/Libraries
%description %{TO_ARCH}
%{name} Cross-%{TO_ARCH} Libraries

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

tar -xaf %SOURCE2
patch -p1<patches/06_wpa_gui_menu_exec_path.patch
patch -p1<patches/12_wpa_gui_knotify_support.patch
patch -p1<patches/0001-P2P-Validate-SSID-element-length-before-copying-it-C.patch
patch -p1<patches/0001-WPS-Fix-HTTP-chunked-transfer-encoding-parser.patch
patch -p1<patches/0001-AP-WMM-Fix-integer-underflow-in-WMM-Action-frame-par.patch
patch -p1<patches/0001-EAP-pwd-peer-Fix-payload-length-validation-for-Commi.patch
patch -p1<patches/0002-EAP-pwd-server-Fix-payload-length-validation-for-Com.patch
patch -p1<patches/0003-EAP-pwd-peer-Fix-Total-Length-parsing-for-fragment-r.patch
patch -p1<patches/0004-EAP-pwd-server-Fix-Total-Length-parsing-for-fragment.patch
patch -p1<patches/0005-EAP-pwd-peer-Fix-asymmetric-fragmentation-behavior.patch
patch -p1<patches/0001-NFC-Fix-payload-length-validation-in-NDEF-record-par.patch
patch -p1<patches/backported-WNM-Ignore-Key-Data-in-WNM-Sleep-Mode-Response-frame.patch
patch -p1<patches/0001-EAP-pwd-server-Fix-last-fragment-length-validation.patch
patch -p1<patches/0001-EAP-pwd-peer-Fix-last-fragment-length-validation.patch
patch -p1<patches/0001-EAP-pwd-peer-Fix-error-path-for-unexpected-Confirm-m.patch

patch -p1<patches/0001-WPS-Reject-a-Credential-with-invalid-passphrase.patch
patch -p1<patches/0002-Reject-psk-parameter-set-with-invalid-passphrase-cha.patch
patch -p1<patches/0003-Remove-newlines-from-wpa_supplicant-config-network-o.patch
patch -p1<patches/0004-Reject-SET_CRED-commands-with-newline-characters-in-.patch
patch -p1<patches/0005-Reject-SET-commands-with-newline-characters-in-the-s.patch

patch -p1<patches/dbus-fix-operations-for-p2p-mgmt.patch
patch -p1<patches/nl80211_dont_call_linux_iface_up_for_a_dedicated_p2p_device.patch
patch -p1<patches/do_not_wait_for_monitor_to_attach_if_no_control_interface.patch
patch -p1<patches/wpa_supplicant_do_not_wait_for_monitor_on_p2p_device_interface.patch
patch -p1<patches/openssl-initialise-pkcs-11.patch
patch -p1<patches/from-upstream-hostapd-fix-SMPS-mode.patch

# ------------------- Build ------------------------------------------
%Build 
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

GCC_VER_STR=`%{target_}gcc -dumpversion`
LDFLAGS=" "

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i486 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-unwind-tables -fno-asynchronous-unwind-tables" ;; esac`
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-unwind-tables -fno-asynchronous-unwind-tables" ;; esac`
LDFLAGS=`case $GCC_VER_STR in 4.[56789].*) echo -static-libgcc ;; esac`
%endif
%if %{_arch} == "arm"
OPTFLAGS="-Os -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
OPT47=
%endif

CFLAGS="$OPTFLAGS $OPT47 -std=gnu99 -D_GNU_SOURCE"
#CFLAGS="$OPTFLAGS $OPT47 -std=gnu99"
CXXFLAGS="$OPTFLAGS"

export CFLAGS CXXFLAGS LDFLAGS

CC=%{target_}gcc
CPP=%{target_}cpp
AR=%{target_}ar
RANLIB=%{target_}ranlib
export CC CPP AR RANLIB

BINDIR=%{_sbindir}
LIBDIR=%{_libdir}
export BINDIR LIBDIR

cd wpa_supplicant
cp defconfig .config
sed -i s:"#CONFIG_LIBNL32=y":"CONFIG_LIBNL32=y": .config
sed -i s:"#CONFIG_DRIVER_NONE=y":"CONFIG_DRIVER_NONE=y": .config
sed -i s:"#CONFIG_EAP_FAST=y":"CONFIG_EAP_FAST=y": .config
sed -i s:"#CONFIG_EAP_SIM=y":"CONFIG_EAP_SIM=y": .config
sed -i s:"#CONFIG_EAP_PSK=y":"CONFIG_EAP_PSK=y": .config
sed -i s:"#CONFIG_EAP_PAX=y":"CONFIG_EAP_PAX=y": .config
sed -i s:"#CONFIG_EAP_AKA=y":"CONFIG_EAP_AKA=y": .config
sed -i s:"#CONFIG_EAP_AKA_PRIME=y":"CONFIG_EAP_AKA_PRIME=y": .config
sed -i s:"#CONFIG_EAP_SAKE=y":"CONFIG_EAP_SAKE=y": .config
sed -i s:"#CONFIG_EAP_GPSK=y":"CONFIG_EAP_GPSK=y": .config
sed -i s:"#CONFIG_EAP_GPSK_SHA256=y":"CONFIG_EAP_GPSK_SHA256=y": .config
sed -i s:"#CONFIG_EAP_TNC=y":"CONFIG_EAP_TNC=y": .config
#sed -i s:"#CONFIG_WPS_ER=y":"CONFIG_WPS_ER=y": .config
#sed -i s:"#CONFIG_WPS_REG_DISABLE_OPEN=y":"CONFIG_WPS_REG_DISABLE_OPEN=y": .config
#sed -i s:"#CONFIG_WPS_NFC=y":"CONFIG_WPS_NFC=y": .config
#sed -i s:"#CONFIG_EAP_IKEV2=y":"CONFIG_EAP_IKEV2=y": .config
#sed -i s:"#CONFIG_EAP_EKE=y":"CONFIG_EAP_EKE=y": .config
#sed -i s:"#CONFIG_PCSC=y":"CONFIG_PCSC=y": .config
#sed -i s:"#CONFIG_HT_OVERRIDES=y":"CONFIG_HT_OVERRIDES=y": .config
#sed -i s:"#CONFIG_VHT_OVERRIDES=y":"CONFIG_VHT_OVERRIDES=y": .config
#sed -i s:"#CONFIG_READLINE=y":"CONFIG_READLINE=y": .config
#sed -i s:"#CONFIG_ELOOP=eloop":"CONFIG_ELOOP=eloop": .config
#sed -i s:"#CONFIG_L2_PACKET=linux":"CONFIG_L2_PACKET=linux": .config
sed -i s:"#CONFIG_IEEE80211W=y":"CONFIG_IEEE80211W=y": .config
sed -i s:"#CONFIG_TLSV11=y":"CONFIG_TLSV11=y": .config
sed -i s:"#CONFIG_TLSV12=y":"CONFIG_TLSV12=y": .config
sed -i s:"#CONFIG_TLSV12=y":"CONFIG_TLSV12=y": .config
#sed -i s:"#CONFIG_CTRL_IFACE_DBUS=y":"CONFIG_CTRL_IFACE_DBUS=y": .config
#sed -i s:"#CONFIG_CTRL_IFACE_DBUS_NEW=y":"CONFIG_CTRL_IFACE_DBUS_NEW=y": .config
sed -i s:"#CONFIG_IEEE80211R=y":"CONFIG_IEEE80211R=y": .config
#sed -i s:"#CONFIG_DEBUG_FILE=y":"CONFIG_DEBUG_FILE=y": .config
sed -i s:"#CONFIG_DEBUG_SYSLOG=y":"CONFIG_DEBUG_SYSLOG=y": .config
#sed -i s:"#CONFIG_DEBUG_SYSLOG_FACILITY=LOG_DAEMON":"CONFIG_DEBUG_SYSLOG_FACILITY=LOG_DAEMON": .config
#sed -i s:"#CONFIG_DEBUG_LINUX_TRACING=y":"CONFIG_DEBUG_LINUX_TRACING=y": .config
#sed -i s:"#CONFIG_DELAYED_MIC_ERROR_REPORT=y":"CONFIG_DELAYED_MIC_ERROR_REPORT=y": .config
sed -i s:"#CONFIG_IEEE80211N=y":"CONFIG_IEEE80211N=y": .config
sed -i s:"#CONFIG_IEEE80211AC=y":"CONFIG_IEEE80211AC=y": .config
sed -i s:"#CONFIG_WNM=y":"CONFIG_WNM=y": .config
sed -i s:"#CONFIG_AP=y":"CONFIG_AP=y": .config
#sed -i s:"#CONFIG_P2P=y":"CONFIG_P2P=y": .config
#sed -i s:"#CONFIG_TDLS=y":"CONFIG_TDLS=y": .config
#sed -i s:"#CONFIG_WIFI_DISPLAY=y":"CONFIG_WIFI_DISPLAY=y": .config
sed -i s:"#CONFIG_AUTOSCAN_PERIODIC=y":"CONFIG_AUTOSCAN_PERIODIC=y": .config


make &>FMake_log.txt

make -C doc/docbook man &>FMake_man_log.txt

%if %{BUIL_WPA_GUI}
cd wpa_gui-qt4
  /usr/%{_lib}/qt4/bin/qmake
  export SUBLIBS=-lrt
  make &>FMake_log.txt
cd ..
%endif

cd ..




# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}/wpa_supplicant
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/dbus-1/system.d
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8

BINDIR=%{_sbindir}
LIBDIR=%{_libdir}
export BINDIR LIBDIR

cd wpa_supplicant

make DESTDIR=$RPM_BUILD_ROOT install &>Finstall_log.txt
cp -a dbus/dbus-wpa_supplicant.conf $RPM_BUILD_ROOT%{_sysconfdir}/dbus-1/system.d/wpa_supplicant.conf
cp -a dbus/fi.epitest.hostap.WPASupplicant.service $RPM_BUILD_ROOT%{_sysconfdir}/dbus-1/system.d/
cp -a dbus/fi.w1.wpa_supplicant1.service $RPM_BUILD_ROOT%{_sysconfdir}/dbus-1/system.d/

cp doc/docbook/*.8 $RPM_BUILD_ROOT%{_mandir}/man8/

cp -a README README-HS20 README-P2P README-WPS $RPM_BUILD_ROOT%{docdir}/wpa_supplicant/
cp -a wpa_supplicant.conf $RPM_BUILD_ROOT%{docdir}/


%if %{BUIL_WPA_GUI}
cd wpa_gui-qt4

mkdir -p $RPM_BUILD_ROOT%{_prefix}/sbin
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps

cp wpa_gui  $RPM_BUILD_ROOT%{_prefix}/sbin
cp -a wpa_gui.desktop $RPM_BUILD_ROOT%{_datadir}/applications
rsvg-convert -w 16 -f png icons/wpa_gui.svg -o $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/wpa_gui.png
rsvg-convert -w 32 -f png icons/wpa_gui.svg -o $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/wpa_gui.png

cd ..
%endif


cd ..

cp -a CONTRIBUTIONS COPYING README $RPM_BUILD_ROOT%{docdir}/


%if %{_CROSS}
TARGET_PRFIX=%{_prefix}
TARGET_CROSS_PRFIX=%{csysdir}
TARGET_NAME=%{target}
MKCROSSDIR=0
export TARGET_PRFIX TARGET_CROSS_PRFIX TARGET_NAME MKCROSSDIR
%SOURCE1
%endif #_CROSS

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} -r %{DestDir} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean 

DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
DEC=%{version}-%{release}.%{_build_cpu}.rpm
DDC=%{_rpmdir}/%{_build_cpu}/%{ALD_Ver}%{CrossDestDir}/%{TO_ARCH}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-gui-$SE $DD/%{name}-gui-$DE
popd

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r sbin usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
popd
%endif  #BUILD_TAR

%post
if test ! -e /etc/wpa_supplicant.conf ; then

  cat > /etc/wpa_supplicant.conf <<EOF
ctrl_interface=/var/run/wpa_supplicant
update_config=1

network={
	key_mgmt=NONE
}
EOF
chmod 0640 /etc/wpa_supplicant.conf

fi

# ------------------- Files ------------------------------------------
%files
%defattr(-, root, root)
%{_sysconfdir}
%{_sbindir}
%{_mandir}
%{docdir}

%if %{BUIL_WPA_GUI}
%files gui
%defattr(-, root, root)
%{_prefix}/sbin
%{_datadir}/applications
%{_datadir}/icons
%endif
